#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e5 + 10;

int n;
bool v[MAX_N];
bool init[MAX_N];
bool fin[MAX_N];

void apply(int x) {
  v[x] ^= 1;
  if(x - 1 >= 1)
    v[x - 1] ^= 1;
  if(x + 1 <= n)
    v[x + 1] ^= 1;
}

const int INF = (1 << 29) - 1;

int go() {
  int cnt = 0;
  for(int i = 2; i <= n; ++i) {
    if(v[i - 1] != fin[i - 1]) {
      cnt++;
      apply(i);
    }
  }
  for(int i = 1; i <= n; ++i)
    if(v[i] != fin[i])
      return INF;
  return cnt;
}

ofstream out("leduri.out");


int main() {
  ifstream in("leduri.in");
  in >> n;
  assert(1 <= n && n <= 100000);

  for(int i = 1; i <= n; ++i) {
    in >> v[i];
    init[i] = v[i];
    assert(v[i] == 0 || v[i] == 1);
  }

  for(int i = 1; i <= n; ++i) {
    in >> fin[i];
    assert(fin[i] == 0 || fin[i] == 1);
  }

  int s1 = go();

  for(int i = 1; i <= n; ++i)
    v[i] = init[i];

  v[1] ^= 1;
  v[2] ^= 1;

  int s2 = go() + 1;
  
  if(s1 >= INF && s2 >= INF) {
    out << "-1\n";
    return 0;
  } else {
    out << min(s1, s2) << "\n";
  }

  return 0;
}
