#include <bits/stdc++.h>
#define inFile "livada.in"
#define outFile "livada.out"
#define Nmax 101
#define Mmax 25001

using namespace std;

int a[Nmax][Mmax], mx[Nmax][Mmax];
long long s[Nmax][Mmax];
long long t[Mmax];
int n, m, R;
long long C;

void Citire()
{
    int i, j, x, y, z, w, u;
    ifstream fin(inFile);
    fin >> n >> m >> C >> R;
    fin >> x >> y >> z >> w >> u;
    for (i = 1; i <= m; ++i)
        fin >> a[1][i];
    for (i = 2; i <= n; ++i)
        fin >> a[i][1];
    for (i = 2; i <= n; ++i)
        for (j = 2; j <= m; ++j)
            a[i][j]=(1LL*x*a[i-1][j] + 1LL*y*a[i][j-1] +
                     1LL*z*a[i-1][j-1] + w) % u;
    fin.close();
}

void Procesare()
{
    int i, j;
    for (i = 1; i <= n; ++i)
        for (j = 1; j <= m; ++j)
        {
            mx[i][j] = max(mx[i][j-1], a[i][j]);
            s[i][j] = s[i][j-1] + a[i][j];
        }
}

/// returneaza cantitatea maxima care se poate culege
/// de pe linia k daca pot culege din copacii care
/// au cel mult cantitatea cant
long long Linia(int k, int cant)
{
    if (cant < mx[k][1]) return 0;
    if (cant >= mx[k][m]) return s[k][m];
    int st, dr, mij, sol;
    sol = 0;
    st = 1; dr = m;
    while (st <= dr)
    {
        mij = (st + dr) / 2;
        if (mx[k][mij] > cant) dr = mij - 1;
        else
        {
            sol = mij;
            st = mij + 1;
        }
    }
    return s[k][sol];
}

void CautBin()
{
    ofstream fout(outFile);
    int st, dr, sol, mij, i;
    long long suma;
    sol = 0;
    st = 1;
    dr = 1000000000;
    while (st <= dr)
    {
        mij = (st + dr) / 2;
        for (i = 1; i <= n; ++i)
            t[i] = Linia(i, mij);
        sort(t + 1, t + n + 1);
        suma = 0;
        for (i = n; i > n - R; i--)
            suma += t[i];
        if (suma >= C)
        {
            sol = mij;
            dr = mij - 1;
        }
        else st = mij + 1;
    }
    fout << sol << "\n";
    fout.close();
}

int main()
{
    Citire();
    Procesare();
    CautBin();
    return 0;
}
