#include <bits/stdc++.h>

using namespace std;

const int MAXN = 500000;
int V[MAXN], n;

long long countSmall(long long x) {
	long long ans = 0;

	for(int i = 1; i <= n; ++i) {
		ans += upper_bound(V + 1, V + n + 1, min((long long)V[n], x / V[i])) - V - 1;
	}

	return ans;
}


long long kth(long long pos) {
	long long ans = 0;
	for(long long i = (1LL << 40); i; i >>= 1LL) {
		int x = countSmall(ans + i);
		if(x < pos) {
			ans += i;
		}
	}
	return ans + 1;
}

template<typename T>
void Read(T &a) {
  char c;
  for(c = getchar(); !isdigit(c); c = getchar());
  for(a = 0; isdigit(c); c = getchar())
    a = a * 10 + c - '0';
}

int main() {
  freopen("dif2.in", "r", stdin);
  freopen("dif2.out", "w", stdout);

	int t;
	long long a, b;

  Read(t);
  Read(n);

	if(t == 2) {
    Read(a);
    Read(b);
  }

	for(int i = 1; i <= n; ++i) {
    Read(V[i]);
	}

	sort(V + 1, V + n + 1);

	if(t == 1) {
		cout << 1LL * V[n] * V[n] - 1LL * V[1] * V[1] << endl;
	} else {
		cout << kth(1LL * n * n - a + 1) - kth(1LL * n * n - b + 1) << endl;
	}


	return 0;
}
