#include <bits/stdc++.h>

using namespace std;


typedef long long LL;
#define int LL

const int MAX_V = 300000 + 1;
const int MAX_N = 300000 + 1;
int v[MAX_N];
int f[MAX_V];
LL S[MAX_V];
int n;

LL p1, p2;

LL test1() {
  return 1LL * v[n] * v[n] - 1LL * v[1] * v[1];
}

LL before(LL prod) {
  LL ret = 0;
  for(int i = min(1LL * v[n], prod); i >= 1; --i) {
    LL other = prod / i;

    if(other <= v[n]) {
      ret += 1LL * S[other] * f[i];
    } else {
      ret += 1LL * S[v[n]] * f[i];
    }
  }

  return ret;
}

LL query(LL poz) {
  LL i, step;
  LL mx = 1LL * v[n] * v[n];
  for(step = 1; step < mx; step *= 2);

  for(i = 0; step; step /= 2) {
    if(i + step <= mx && before(i + step) < poz)
      i += step;
  }
  return i + 1;
}

int32_t main() {
  ifstream in("dif2.in");
  int c;
  in >> c;
  assert(c == 1 || c == 2);
  
  in >> n;
  assert(3 < n && n < MAX_N);

  if(c == 2) {
    in >> p1 >> p2;
  }

  for(int i = 1; i <= n; ++i) {
    in >> v[i];
    assert(1 <= v[i] && v[i] < MAX_V);
    f[v[i]]++;
  }

  for(int i = 1; i < MAX_V; ++i) {
    S[i] = S[i - 1] + f[i];
  }

  sort(v + 1, v + n + 1);

  ofstream out("dif2.out");

  if(c == 1) {
    out << test1() << "\n";
    return 0;
  } else {
    p2 = 1LL * n * n - p2 + 1;
    p1 = 1LL * n * n - p1 + 1;
    out << query(p1) - query(p2) << "\n";
  }

  return 0;
}
